#include "testlib.h"

#include <iostream>
#include <vector>
#include <string>

using namespace std;

void check_testcase() {
    int n = inf.readInt();
    int m = inf.readInt();
    
    vector<int> r(m + 1), w(m + 1);
    for (int i = 1; i <= m; i++) {
        r[i] = inf.readInt();
        w[i] = inf.readInt();
    }
    
    string jury_ans = ans.readToken();
    string cont_ans = ouf.readToken("[A-Z]*", "answer");
    
    if (jury_ans == "IMPOSSIBLE" and cont_ans != "IMPOSSIBLE") {
        quit(_wa, "Wrong output");
    }
    if (jury_ans == "IMPOSSIBLE") {
        return;
    }
    if (cont_ans == "IMPOSSIBLE") {
        quit(_wa, "Wrong output");
    }
    
    if (cont_ans.size() != n) {
        quit(_pe, "Incorrect output format");
    }
    
    vector<int> prefix_sums(n + 1, 0);
    for (int i = 0; i < n; i++) {
        if (cont_ans[i] != 'R' and cont_ans[i] != 'W') {
            quitf(_pe, "Incorrect output format");
        }
        prefix_sums[i + 1] = prefix_sums[i] + int(cont_ans[i] == 'R');
    }
    
    for (int i = 1; i <= m; i++) {
        bool matched = false;
        for (int j = 0; j + r[i] + w[i] <= n; j++) {
            if (prefix_sums[j + r[i] + w[i]] - prefix_sums[j] == r[i]) {
                matched = true;
                break;
            }
        }
        if (!matched) {
            quitf(_wa, "Constraints of critic %d are not met", i);
        }
    }
}

int main(int argc, char** argv) {
    registerTestlibCmd(argc, argv);
    
    int t = inf.readInt();
    
    for (int i = 1; i <= t; i++) {
        setTestCase(i);
        check_testcase();
    }
    
    quit(_ok, "Accepted");

    return 0;
}
