#include <iostream>
#include <vector>
#include <string>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    
    vector<int> r(m + 1), w(m + 1);
    for (int i = 1; i <= m; i++)
        cin >> r[i] >> w[i];
    
    for (int mask = 0; mask < (1 << n); mask++) {
        string S;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) S.push_back('R');
            else S.push_back('W');
        }
        
        bool works = true;
        for (int i = 1; i <= m; i++) {
            bool satisfied = false;
            for (int j = 0; j + r[i] + w[i] <= n; j++) {
                int num_r = 0, num_w = 0;
                for (int k = 0; k < r[i] + w[i]; k++) {
                    if (S[j + k] == 'R') ++num_r;
                    else ++num_w;
                }
                if (num_r == r[i] and num_w == w[i]) {
                    satisfied = true;
                    break;
                }
            }
            if (!satisfied) {
                works = false;
                break;
            }
        }
        
        if (works) {
            cout << S << endl;
            return;
        }
    }
    
    cout << "IMPOSSIBLE" << endl;
}

int main() {
    int t;
    cin >> t;
    
    for (int i = 1; i <= t; i++) {
        solve();
    }
    
    return 0;
}
